unit Office97;

interface

{$IFDEF DELPHI_OFFICE97_3+}
  {$UNDEF DELPHI_OFFICE97_3+}
{$ENDIF}

{$IFDEF WIN32}
  {$IFNDEF VER90}
    {$IFNDEF VER93}
      {$DEFINE DELPHI_OFFICE97_3+}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

const
  WM_DRAG = WM_USER + 1;

type
  TInplaceEdit97 = class(TEdit)
  private
    { Private declarations }
    Dropped: Boolean;
    procedure WMKeyDown(var Message: TMessage); message WM_KEYDOWN;
    procedure WMKeyUp(var Message: TMessage); message WM_KEYUP;
    procedure WMSysKeyDown(var Message: TMessage); message WM_SYSKEYDOWN;
    procedure WMSysKeyUp(var Message: TMessage); message WM_SYSKEYUP;
    procedure WMChar(var Message: TWMChar); message WM_CHAR;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
  end;

  TInplaceButton97 = class(TSpeedButton)
  private
    { Private declarations }
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
  protected
    { Protected declarations }
    procedure Paint; override;
  public
    { Public declarations }
  published
    { Published declarations }
  end;

  TInplaceComboBox97 = class(TComboBox)
  private
    { Private declarations }
    KeyIgnore: Boolean;
    FDroppedWidth: Integer;
    FOnSetText: TNotifyEvent;
    procedure CMColorChanged(var Message: TMessage); message CM_COLORCHANGED;
    procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;
    procedure WMKeyDown(var Message: TMessage); message WM_KEYDOWN;
    procedure WMSetText(var Message: TWMSetText); message WM_SETTEXT;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    procedure WMMouseMove(var Message: TWMMouseMove); message WM_MOUSEMOVE;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
  protected
    { Protected declarations }
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property OnSetText: TNotifyEvent read FOnSetText write FOnSetText;
  end;

  TDrawItemEvent97 = procedure(Sender: TObject; Canvas: TCanvas; Index: Integer;
    Rect: TRect; State: TOwnerDrawState) of object;
  TComboMessage = procedure(Message: TMessage; var Default: Boolean) of object;

  TComboWinControl = class(TWinControl)
  private
    function GetTabStop: Boolean;
    procedure SetTabStop(Value: Boolean);
  public
    property ControlTabStop: Boolean read GetTabStop write SetTabStop;
  end;

  TComboBox97 = class(TComboWinControl)
  private
    { Private declarations }
    Editor: TInplaceEdit97;
    Button: TInplaceButton97;
    ComboBox: TInplaceComboBox97;
    DropDownEx: Boolean;
    DraggingStatus: Integer;
    Dropped: Boolean;
    EditUpdate: Boolean;
    FAutoSize: Boolean;
    FBackgroundColor: TColor;
    FDropDownAlignment: TAlignment;
    FTabStop: Boolean;
    FOnChange: TNotifyEvent;
    FOnClick: TNotifyEvent;
    FOnCloseUp: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    FOnDragDrop: TDragDropEvent;
    FOnDragOver: TDragOverEvent;
    FOnDrawItem: TDrawItemEvent97;
    FOnDropDown: TNotifyEvent;
    FOnEnter: TNotifyEvent;
    FOnExit: TNotifyEvent;
    FOnKeyDown: TKeyEvent;
    FOnKeyPress: TKeyPressEvent;
    FOnKeyUp: TKeyEvent;
    FOnMeasureItem: TMeasureItemEvent;
    FOnMessage: TComboMessage;
    procedure ButtonDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ButtonDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure ComboBoxDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ComboBoxMeasureItem(Control: TWinControl; Index: Integer; var Height: Integer);
    procedure ComboBoxChange(Sender: TObject);
    procedure ComboBoxClick(Sender: TObject);
    procedure ComboBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ComboBoxDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure ComboBoxEnter(Sender: TObject);
    procedure ComboBoxExit(Sender: TObject);
    procedure ComboBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBoxKeyPress(Sender: TObject; var Key: Char);
    procedure ComboBoxKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBoxSetText(Sender: TObject);
    procedure EditorChange(Sender: TObject);
    procedure EditorDblClick(Sender: TObject);
    procedure EditorDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure EditorDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure EditorEnter(Sender: TObject);
    procedure EditorExit(Sender: TObject);
    procedure EditorKeyPress(Sender: TObject; var Key: Char);
    procedure DraggingOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    function GetColor: TColor;
    function GetComboBoxHandle: HWND;
    function GetDropDownCount: Integer;
    function GetDroppedWidth: Integer;
    function GetEditHandle: HWND;
    function GetItemHeight: Integer;
    function GetItems: TStrings;
    function GetMaxLength: Integer;
    function GetMouseIn: Boolean;
    function GetParentColor: Boolean;
    function GetSorted: Boolean;
    function GetStyle: TComboBoxStyle;
    function GetText: TCaption;
    procedure SetAutoSize(Value: Boolean);
    procedure SetBackgroundColor(Value: TColor);
    procedure SetColor(Value: TColor);
    procedure SetDropDownCount(Value: Integer);
    procedure SetDroppedWidth(Value: Integer);
    procedure SetItemHeight(Value: Integer);
    procedure SetItems(Value: TStrings);
    procedure SetMaxLength(Value: Integer);
    procedure SetParentColor(Value: Boolean);
    procedure SetSorted(Value: Boolean);
    procedure SetStyle(Value: TComboBoxStyle);
    procedure SetTabStop(Value: Boolean);
    procedure SetText(Value: TCaption);
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMDrag(var Message: TMessage); message WM_DRAG;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint(var Message: TWMNCPaint); message WM_NCPAINT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  protected
    { Protected declarations }
    property Caption;
    property ComboBoxHandle: HWND read GetComboBoxHandle;
    property EditHandle: HWND read GetEditHandle;
    property MouseIn: Boolean read GetMouseIn;
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property AutoSize: Boolean read FAutoSize write SetAutoSize default True;
    property BackgroundColor: TColor read FBackgroundColor write SetBackgroundColor default clBtnFace;
    property Color: TColor read GetColor write SetColor default clWindow;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property DropDownAlignment: TAlignment read FDropDownAlignment write FDropDownAlignment default taLeftJustify;
    property DropDownCount: Integer read GetDropDownCount write SetDropDownCount default 8;
    property DroppedWidth: Integer read GetDroppedWidth write SetDroppedWidth;
    property Enabled;
    property Font;
    {$IFDEF DELPHI_OFFICE97_3+}
    property ImeMode;
    property ImeName;
    {$ENDIF}
    property ItemHeight: Integer read GetItemHeight write SetItemHeight;
    property Items: TStrings read GetItems write SetItems;
    property MaxLength: Integer read GetMaxLength write SetMaxLength default 0;
    property ParentColor: Boolean read GetParentColor write SetParentColor;
    property ParentCtl3D;
    property ParentFont;
    property PopupMenu;
    property ShowHint;
    property Sorted: Boolean read GetSorted write SetSorted default False;
    property Style: TComboBoxStyle read GetStyle write SetStyle default csDropDown;
    property TabOrder;
    property TabStop: Boolean read FTabStop write SetTabStop default True;
    property Text: TCaption read GetText write SetText;
    property ParentShowHint;
    property Visible;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnCloseUp: TNotifyEvent read FOnCloseUp write FOnCloseUp;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnDragDrop: TDragDropEvent read FOnDragDrop write FOnDragDrop;
    property OnDragOver: TDragOverEvent read FOnDragOver write FOnDragOver;
    property OnDrawItem: TDrawItemEvent97 read FOnDrawItem write FOnDrawItem;
    property OnDropDown: TNotifyEvent read FOnDropDown write FOnDropDown;
    property OnEndDrag;
    property OnEnter: TNotifyEvent read FOnEnter write FOnEnter;
    property OnExit: TNotifyEvent read FOnExit write FOnExit;
    property OnKeyDown: TKeyEvent read FOnKeyDown write FOnKeyDown;
    property OnKeyPress: TKeyPressEvent read FOnKeyPress write FOnKeyPress;
    property OnKeyUp: TKeyEvent read FOnKeyUp write FOnKeyUp;
    property OnMeasureItem: TMeasureItemEvent read FOnMeasureItem write FOnMeasureItem;
    property OnMessage: TComboMessage read FOnMessage write FOnMessage;
    property OnStartDrag;
  end;

  TDisabledState = (dsNormal, dsOffice97);

  TCustomEdit97 = class(TCustomEdit)
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  end;

  TEdit97 = class(TCustomEdit97)
  private
    { Private declarations }
    FAutoSize: Boolean;
    FBackgroundColor: TColor;
    FDisabledState: TDisabledState;
    function GetBorderStyle: TBorderStyle;
    function GetMouseIn: Boolean;
    procedure SetAutoSize(Value: Boolean);
    procedure SetBackgroundColor(Value: TColor);
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetDisabledState(Value: TDisabledState);
    function CalcAdjustHeight: Integer;
    procedure AdjustHeight;
    procedure UpdateHeight;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure WMNCPaint(var Message: TWMNCPaint); message WM_NCPAINT;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure WMKillFocus(var Message: TWMKillFocus); message WM_KILLFOCUS;
  protected
    { Protected declarations }
    property MouseIn: Boolean read GetMouseIn;
    procedure CreateWnd; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property AutoSelect;
    property AutoSize: Boolean read FAutoSize write SetAutoSize default True;
    property BackgroundColor: TColor read FBackgroundColor write SetBackgroundColor default clBtnFace;
    property BorderStyle: TBorderStyle read GetBorderStyle write SetBorderStyle default bsNone;
    property CharCase;
    property Color;
    property Ctl3D;
    property DisabledState: TDisabledState read FDisabledState write SetDisabledState default dsOffice97;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    {$IFDEF DELPHI_OFFICE97_3+}
    property ImeMode;
    property ImeName;
    {$ENDIF}
    property MaxLength;
    property OEMConvert;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

  TSpeedButton97 = class(TSpeedButton)
  private
    { Private declarations }
    InClick: Boolean;
    Pattern: TBitmap;
    FBorderAlwaysVisible: Boolean;
    FBackgroundColor: TColor;
    FNoBorder: Boolean;
    FNoHighlight: Boolean;
    FOpaque: Boolean;
    function GetFlat: Boolean;
    function GetMouseIn: Boolean;
    procedure SetBorderAlwaysVisible(Value: Boolean);
    procedure SetBackgroundColor(Value: TColor);
    procedure SetFlat(Value: Boolean);
    procedure SetNoBorder(Value: Boolean);
    procedure SetNoHighlight(Value: Boolean);
    procedure SetOpaque(Value: Boolean);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
  protected
    { Protected declarations }
    procedure CreateBrushPattern;
    procedure DrawBorder;
    procedure Paint; override;
    property MouseIn: Boolean read GetMouseIn;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    { Published declarations }
    property BorderAlwaysVisible: Boolean read FBorderAlwaysVisible write SetBorderAlwaysVisible default False;
    property BackgroundColor: TColor read FBackgroundColor write SetBackgroundColor default clBtnFace;
    property Flat: Boolean read GetFlat write SetFlat default True;
    property NoBorder: Boolean read FNoBorder write SetNoBorder default False;
    property NoHighlight: Boolean read FNoHighlight write SetNoHighlight default False;
    property Opaque: Boolean read FOpaque write SetOpaque default True;
  end;

procedure Register;

implementation

type
  TLum = 0..240;

const
  BORDERWIDTH = 3;
  BUTTONWIDTH = 11;

var
  MouseInControl97: TComponent;
  FocusedControl97: TWinControl;
  GlobalBrush: TBrush;

procedure Register;
begin
  RegisterComponents('Office97', [TComboBox97]);
  RegisterComponents('Office97', [TEdit97]);
  RegisterComponents('Office97', [TSpeedButton97]);
end;

function Min(A, B: Integer): Integer;
begin
  if A < B then
    Result := A
  else
    Result := B;
end;

function Max(A, B: Integer): Integer;
begin
  if A > B then
    Result := A
  else
    Result := B;
end;

function LumColor(BasicColor: TColor; Level: TLum): TColor;
var
  R, G, B, AA, BB: Integer;
  Lum: Extended;
begin
  B := (BasicColor and $00FF0000) shr 16;
  G := (BasicColor and $0000FF00) shr 8;
  R := BasicColor and $000000FF;
  AA := Min(Min(R, G), B);
  BB := Max(Max(R, G), B);
  Lum := (AA * 240/255) + ((BB * 240/255) - (AA * 240/255)) / 2;
  if (R + G + B = 0) or (R + G + B = 3 * 255) then
  begin
    R := 127;
    B := 127;
    G := 127;
  end
  else
  if Lum <> 120 then
  begin
    if Lum > 120 then
    begin
      R := Round(255 - (255 - R) * 120 / (Min(Round(2 * Lum), Round(480 - 2 * Lum)) div 2));
      G := Round(255 - (255 - G) * 120 / (Min(Round(2 * Lum), Round(480 - 2 * Lum)) div 2));
      B := Round(255 - (255 - B) * 120 / (Min(Round(2 * Lum), Round(480 - 2 * Lum)) div 2));
    end
    else
    begin
      R := Round(R * 120 / (Min(Round(2 * Lum), Round(480 - 2 * Lum)) div 2));
      G := Round(G * 120 / (Min(Round(2 * Lum), Round(480 - 2 * Lum)) div 2));
      B := Round(B * 120 / (Min(Round(2 * Lum), Round(480 - 2 * Lum)) div 2));
    end;
  end;
  if Level <> 120 then
  begin
    if Level > 120 then
    begin
      R := Round(R + (255 - R) * (Level - 120) / 120);
      G := Round(G + (255 - G) * (Level - 120) / 120);
      B := Round(B + (255 - B) * (Level - 120) / 120);
    end
    else
    begin
      R := Round(R * Level / 120);
      G := Round(G * Level / 120);
      B := Round(B * Level / 120);
    end;
  end;
  Result := (Max(Min(B, 255), 0) shl 16) + (Max(Min(G, 255), 0) shl 8) +
    Max(Min(R, 255), 0);
end;

procedure UpdateMouseInControl;
begin
  if (MouseInControl97 is TEdit97) then
    SendMessage((MouseInControl97 as TEdit97).Handle, WM_NCPAINT, 0, 0)
  else
  if (MouseInControl97 is TComboBox97) then
    SendMessage((MouseInControl97 as TComboBox97).Handle, WM_NCPAINT, 0, 0)
end;

function TComboWinControl.GetTabStop: Boolean;
begin
  Result := TabStop;
end;

procedure TComboWinControl.SetTabStop(Value: Boolean);
begin
  TabStop := Value;
end;

procedure TInplaceEdit97.WMPaint(var Message: TWMPaint);
begin
  inherited;
  (Parent as TComboBox97).ComboBoxDrawItem((Parent as TComboBox97).ComboBox,
    (Parent as TComboBox97).ComboBox.ItemIndex, Rect(0, 0, 0, 0),
    [odSelected, odFocused]);
end;

procedure TInplaceEdit97.WMSetFocus(var Message: TWMSetFocus);
var
  AControl: TWinControl;
begin
  inherited;
  AControl := FocusedControl97;
  FocusedControl97 := Parent;
  if (AControl <> nil) then
    SendMessage(AControl.Handle, WM_NCPAINT, 0, 0)
  else
  if (MouseInControl97 <> nil) then
    UpdateMouseInControl;
  SendMessage(Parent.Handle, WM_NCPAINT, 0, 0);
end;

procedure TInplaceEdit97.WMKillFocus(var Message: TWMKillFocus);
begin
  inherited;
  if FocusedControl97 = Parent then
  begin
    FocusedControl97 := nil;
    if (MouseInControl97 <> nil) then
      UpdateMouseInControl;
  end;
  SendMessage(Parent.Handle, WM_NCPAINT, 0, 0);
end;

procedure TInplaceEdit97.WMKeyDown(var Message: TMessage);
var
  Change: Boolean;
  I: Integer;
begin
  Dropped := (Parent as TComboBox97).ComboBox.DroppedDown;
  if ((TWMKeyDown(Message).CharCode = vk_Up) or
    (TWMKeyDown(Message).CharCode = vk_Down)) and
    not((TWMKeyDown(Message).KeyData and $20000000) <> 0) and not(Dropped) then
  begin
    if (Parent as TComboBox97).ComboBox.Items.Strings[
      (Parent as TComboBox97).ComboBox.ItemIndex] <> Text then
    begin
      Change := False;
      for I := 0 to (Parent as TComboBox97).ComboBox.Items.Count - 1 do
      begin
        if (Parent as TComboBox97).ComboBox.Items.Strings[I] = Text then
        begin
          (Parent as TComboBox97).ComboBox.ItemIndex := I;
          (Parent as TComboBox97).ComboBox.KeyIgnore := True;
          SelStart := 0;
          SelLength := -1;
          Change := True;
          Break;
        end;
      end;
      if not Change then
      begin
        (Parent as TComboBox97).ComboBox.ItemIndex := 0;
        (Parent as TComboBox97).ComboBox.KeyIgnore := True;
        Text := (Parent as TComboBox97).ComboBox.Text;
        SelStart := 0;
        SelLength := -1;
      end;
    end
    else
    begin
      if (TWMKeyDown(Message).CharCode = vk_Up) then
        (Parent as TComboBox97).ComboBox.ItemIndex :=
          Max(0, (Parent as TComboBox97).ComboBox.ItemIndex - 1)
      else
        (Parent as TComboBox97).ComboBox.ItemIndex :=
          Min((Parent as TComboBox97).ComboBox.Items.Count - 1,
          (Parent as TComboBox97).ComboBox.ItemIndex + 1);
      (Parent as TComboBox97).ComboBox.KeyIgnore := True;
      Text := (Parent as TComboBox97).ComboBox.Text;
      SelStart := 0;
      SelLength := -1;
    end;
  end;
  SendMessage((Parent as TComboBox97).ComboBox.Handle, WM_KEYDOWN,
    Message.wParam, Message.lParam);
  if (TWMKeyDown(Message).CharCode = vk_Left) or
    (TWMKeyDown(Message).CharCode = vk_Right) or
    (TWMKeyDown(Message).CharCode = vk_Home) or
    (TWMKeyDown(Message).CharCode = vk_End) then
    inherited;
end;

procedure TInplaceEdit97.WMKeyUp(var Message: TMessage);
begin
  SendMessage((Parent as TComboBox97).ComboBox.Handle, WM_KEYUP,
    Message.wParam, Message.lParam);
end;

procedure TInplaceEdit97.WMSysKeyDown(var Message: TMessage);
begin
  SendMessage((Parent as TComboBox97).ComboBox.Handle, WM_SYSKEYDOWN,
    Message.wParam, Message.lParam);
end;

procedure TInplaceEdit97.WMSYSKeyUp(var Message: TMessage);
begin
  SendMessage((Parent as TComboBox97).ComboBox.Handle, WM_SYSKEYUP,
    Message.wParam, Message.lParam);
end;

procedure TInplaceEdit97.WMChar(var Message: TWMChar);
begin
  if not(((Message.CharCode = vk_Return) or (Message.CharCode = vk_Escape)) and
    Dropped) then
    inherited;
end;

procedure TInplaceEdit97.WMLButtonDown(var Message: TWMLButtonDown);
begin
  if ((Parent as TComboBox97).DragMode = dmAutomatic) then
  begin
    SendMessage(Parent.Handle, WM_DRAG, 0, 0);
  end
  else
    inherited;
end;

procedure TInplaceButton97.WMLButtonDown(var Message: TWMLButtonDown);
begin
  if ((Parent as TComboBox97).DragMode = dmAutomatic) then
  begin
    SendMessage(Parent.Handle, WM_DRAG, 0, 0);
  end
  else
  if (Message.XPos > 0) or ((Parent as TComboBox97).Style in
    [csDropDownList, csOwnerDrawFixed, csOwnerDrawVariable]) then
  begin
    (Parent as TComboBox97).DropDownEx := not (Parent as TComboBox97).Dropped;
    if (Parent as TComboBox97).DropDownEx then
      SendMessage((Parent as TComboBox97).ComboBox.Handle, CB_SHOWDROPDOWN, 1, 0)
  end;
end;

procedure TInplaceButton97.WMLButtonDblClk(var Message: TWMLButtonDblClk);
begin
  // nothing
end;

procedure TInplaceButton97.Paint;
var
  R: TRect;
begin
  if (Parent as TComboBox97).Enabled then
    Canvas.Brush.Color := clBtnFace
  else
    Canvas.Brush.Color := (Parent as TComboBox97).BackgroundColor;
  Canvas.FillRect(Rect(0, 0, Width, Height));
  Canvas.Font.Name := 'Marlett';
  Canvas.Font.Size := 8;
  R := Rect(1 + Ord(Down), 2*Ord(Down), Width, Height - 2);
  DrawText(Canvas.Handle, '6', 1, R, DT_SINGLELINE or DT_VCENTER);
  if not(Parent as TComboBox97).Enabled then
    Canvas.Pen.Color := (Parent as TComboBox97).BackgroundColor
  else
  if (Parent as TComboBox97).MouseIn then
    Canvas.Pen.Color := clBtnFace
  else
    Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210);
  Canvas.MoveTo(0, 0);
  Canvas.LineTo(0, Height);
  if (Parent as TComboBox97).MouseIn then
  begin
    if Down then
      Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 120)
    else
      Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210);
    Canvas.MoveTo(1, 0);
    Canvas.LineTo(1, Height);
  end
  else
  begin
    if (Parent as TComboBox97).Enabled then
      Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210)
    else
    if (Parent as TComboBox97).Enabled then
      Canvas.Pen.Color := clBtnFace
    else
      Canvas.Pen.Color := (Parent as TComboBox97).BackgroundColor;
    Canvas.MoveTo(1, 0);
    Canvas.LineTo(1, Height);
  end;
end;

constructor TInplaceComboBox97.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  KeyIgnore := False;
end;

procedure TInplaceComboBox97.CMColorChanged(var Message: TMessage);
begin
  inherited;
  SendMessage((Parent as TComboBox97).Handle, WM_NCPAINT, 0, 0);
end;

procedure TInplaceComboBox97.CNCommand(var Message: TWMCommand);
var
  CalcHeight: Integer;
begin
  inherited;
  case Message.NotifyCode of
    CBN_SELCHANGE:
      (Parent as TComboBox97).Editor.Repaint;
    CBN_DROPDOWN:
    begin
      (Parent as TComboBox97).Dropped := True;
      if not (Parent as TComboBox97).Editor.Enabled then
        SetFocus
      else
        (Parent as TComboBox97).Editor.SetFocus;
      (Parent as TComboBox97).Button.Down := True;
      CalcHeight := DropDownCount * ItemHeight;
      if CalcHeight = 0 then
        CalcHeight := ItemHeight;
      CalcHeight := CalcHeight + 2*GetSystemMetrics(SM_CYBORDER);
      CalcHeight := CalcHeight + (Parent as TComboBox97).ClientToScreen(
        Point(0, (Parent as TComboBox97).Height)).Y;
      if CalcHeight > GetSystemMetrics(SM_CYSCREEN) then
        Top := -BORDERWIDTH
      else
        Top := (Parent as TComboBox97).Height - Height - BORDERWIDTH;
      if (Parent as TComboBox97).DropDownAlignment = taLeftJustify then
        Left := -BORDERWIDTH
      else
      if (Parent as TComboBox97).DropDownAlignment = taRightJustify then
        Left := (Parent as TComboBox97).Width - BORDERWIDTH - Abs(FDroppedWidth)
      else
        Left := ((Parent as TComboBox97).Width - 2*BORDERWIDTH - Abs(FDroppedWidth)) div 2;
      (Parent as TComboBox97).ComboBoxDrawItem((Parent as TComboBox97).ComboBox,
        (Parent as TComboBox97).ComboBox.ItemIndex, Rect(0,0,0,0),
        [odFocused, odSelected]);
      SendMessage((Parent as TComboBox97).Handle, WM_NCPAINT, 0, 0);
      SendMessage(Handle, CB_SETDROPPEDWIDTH, Abs(FDroppedWidth), 0);
      if Assigned((Parent as TComboBox97).FOnDropDown) then
        (Parent as TComboBox97).FOnDropDown((Parent as TComboBox97));
    end;
    CBN_CLOSEUP:
    begin
      (Parent as TComboBox97).Dropped := False;
      (Parent as TComboBox97).Button.Down := False;
      (Parent as TComboBox97).ComboBoxDrawItem((Parent as TComboBox97).ComboBox,
        (Parent as TComboBox97).ComboBox.ItemIndex, Rect(0,0,0,0),
        [odFocused, odSelected]);
      SendMessage((Parent as TComboBox97).Handle, WM_NCPAINT, 0, 0);
      if Assigned((Parent as TComboBox97).FOnCloseUp) then
        (Parent as TComboBox97).FOnCloseUp((Parent as TComboBox97));
    end;
  end;
end;

procedure TInplaceComboBox97.WMLButtonUp(var Message: TWMLButtonUp);
begin
  if not (Parent as TComboBox97).DropDownEx then
    inherited
  else
    (Parent as TComboBox97).DropDownEx := False;
end;

procedure TInplaceComboBox97.WMKeyDown(var Message: TMessage);
begin
  if not KeyIgnore then
    inherited;
  KeyIgnore := False;
end;

procedure TInplaceComboBox97.WMMouseMove(var Message: TWMMouseMove);
begin
  inherited;
  if (Message.YPos >= (Parent as TComboBox97).Width) then
    (Parent as TComboBox97).DropDownEx := False;
end;

procedure TInplaceComboBox97.WMSetFocus(var Message: TWMSetFocus);
var
  AControl: TWinControl;
begin
  inherited;
  AControl := FocusedControl97;
  FocusedControl97 := Parent;
  if (AControl <> nil) then
    SendMessage(AControl.Handle, WM_NCPAINT, 0, 0)
  else
  if (MouseInControl97 <> nil) then
    UpdateMouseInControl;
  SendMessage(Parent.Handle, WM_NCPAINT, 0, 0);
end;

procedure TInplaceComboBox97.WMKillFocus(var Message: TWMKillFocus);
begin
  inherited;
  if FocusedControl97 = Parent then
  begin
    FocusedControl97 := nil;
    if (MouseInControl97 <> nil) then
      UpdateMouseInControl;
  end;
  SendMessage(Parent.Handle, WM_NCPAINT, 0, 0);
end;

procedure TInplaceComboBox97.WndProc(var Message: TMessage);
var
  Default: Boolean;
begin
  case Message.Msg of
    CB_ADDSTRING,
    CB_DELETESTRING,
    CB_DIR,
    CB_FINDSTRING,
    CB_FINDSTRINGEXACT,
    CB_GETCOUNT,
    CB_GETCURSEL,
    CB_GETDROPPEDCONTROLRECT,
    CB_GETEDITSEL,
    CB_GETEXTENDEDUI,
    CB_GETITEMDATA,
    CB_GETITEMHEIGHT,
    CB_GETLBTEXT,
    CB_GETLBTEXTLEN,
    CB_GETLOCALE,
    CB_INSERTSTRING,
    CB_LIMITTEXT,
    CB_RESETCONTENT,
    CB_SELECTSTRING,
    CB_SETCURSEL,
    CB_SETEDITSEL,
    CB_SETEXTENDEDUI,
    CB_SETITEMDATA,
    CB_SETITEMHEIGHT,
    CB_SETLOCALE,
    CB_SHOWDROPDOWN,
    CN_COMMAND,
    WM_COMMAND,
    WM_COMPAREITEM,
    WM_DRAWITEM,
    WM_MEASUREITEM:
      begin
        Default := True;
        if Assigned((Parent as TComboBox97).FOnMessage) then
          (Parent as TComboBox97).FOnMessage(Message, Default);
        if Default then
          inherited WndProc(Message);
      end;
  else
    inherited WndProc(Message);
  end;
end;

procedure TInplaceComboBox97.WMSetText(var Message: TWMSetText);
begin
  inherited;
  if Assigned(FOnSetText) then
    FOnSetText(Self);
end;

constructor TComboBox97.Create(AOwner: TComponent);
begin
  inherited;
  ControlTabStop := False;
  Editor := TInplaceEdit97.Create(Self);
  Editor.Parent := Self;
  Editor.AutoSize := False;
  Editor.BorderStyle := bsNone;
  Editor.ParentShowHint := False;
  Editor.TabStop := True;
  Editor.OnChange := EditorChange;
  Editor.OnDblClick := EditorDblClick;
  Editor.OnDragDrop := EditorDragDrop;
  Editor.OnDragOver := EditorDragOver;
  Editor.OnEnter := EditorEnter;
  Editor.OnExit := EditorExit;
  Editor.OnKeyPress := EditorKeyPress;
  Button := TInplaceButton97.Create(Self);
  Button.Flat := True;
  Button.Parent := Self;
  Button.Width := BUTTONWIDTH;
  Button.AllowAllUp := True;
  Button.GroupIndex := 1;
  Button.ParentShowHint := False;
  Button.OnDragDrop := ButtonDragDrop;
  Button.OnDragOver := ButtonDragOver;
  ComboBox := TInplaceComboBox97.Create(Self);
  ComboBox.Parent := Self;
  ComboBox.ParentShowHint := False;
  ComboBox.SetBounds(-BORDERWIDTH, 0, 1, 21);
  ComboBox.SendToBack;
  ComboBox.OnDrawItem := ComboBoxDrawItem;
  ComboBox.OnMeasureItem := ComboBoxMeasureItem;
  ComboBox.OnChange := ComboBoxChange;
  ComboBox.OnClick := ComboBoxClick;
  ComboBox.OnDragDrop := ComboBoxDragDrop;
  ComboBox.OnDragOver := ComboBoxDragOver;
  ComboBox.OnEnter := ComboBoxEnter;
  ComboBox.OnExit := ComboBoxExit;
  ComboBox.OnKeyDown := ComboBoxKeyDown;
  ComboBox.OnKeyPress := ComboBoxKeyPress;
  ComboBox.OnKeyUp := ComboBoxKeyUp;
  ComboBox.OnSetText := ComboBoxSetText;
  ComboBox.TabStop := False;
  BoundsRect := Rect(Left, Top, Left + 121, Top + 19);
  FAutoSize := True;
  FBackgroundColor := clBtnFace;
  FTabStop := True;
  DraggingStatus := 1;
end;

destructor TComboBox97.Destroy;
begin
  Button.Free;
  Editor.Free;
  inherited;
end;

procedure TComboBox97.WndProc(var Message: TMessage);
begin
  case Message.Msg of
    CB_ADDSTRING,
    CB_DELETESTRING,
    CB_DIR,
    CB_FINDSTRING,
    CB_FINDSTRINGEXACT,
    CB_GETCOUNT,
    CB_GETCURSEL,
    CB_GETDROPPEDCONTROLRECT,
    CB_GETEDITSEL,
    CB_GETEXTENDEDUI,
    CB_GETITEMDATA,
    CB_GETITEMHEIGHT,
    CB_GETLBTEXT,
    CB_GETLBTEXTLEN,
    CB_GETLOCALE,
    CB_INSERTSTRING,
    CB_LIMITTEXT,
    CB_RESETCONTENT,
    CB_SELECTSTRING,
    CB_SETCURSEL,
    CB_SETEDITSEL,
    CB_SETEXTENDEDUI,
    CB_SETITEMDATA,
    CB_SETITEMHEIGHT,
    CB_SETLOCALE,
    CB_SHOWDROPDOWN:
      Message.Result :=
        SendMessage(ComboBox.Handle, Message.Msg, Message.wParam, Message.lParam);
  else
    inherited WndProc(Message);
  end;
end;

procedure TComboBox97.ComboBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  R: TRect;
  editDC: HDC;
  aCanvas: TCanvas;
begin
  if (Enabled <> Editor.Enabled) and (Style in [csDropDown, csSimple]) then
    Editor.Enabled := Enabled;
  if not(Enabled) then
  begin
    editDC := GetDC(Editor.Handle);
    try
      GlobalBrush.Color := ColorToRGB(FBackgroundColor);
      FillRect(editDC, Editor.ClientRect, GlobalBrush.Handle);
    finally
      ReleaseDC(Editor.Handle, editDC);
    end;
  end;
  if (Style in [csDropDown, csSimple]) or not(Enabled) then
    Exit;
  R := Rect;
  if R.Left = R.Right then
  begin
    editDC := GetDC(Editor.Handle);
    aCanvas := TCanvas.Create;
    try
      R := Classes.Rect(0, 0, Editor.Width - 1, Editor.Height);
      aCanvas.Handle := editDC;
      aCanvas.Font.Assign((Control as TComboBox).Canvas.Font);
      aCanvas.Brush.Assign((Control as TComboBox).Canvas.Brush);
      aCanvas.Pen.Assign((Control as TComboBox).Canvas.Pen);
      if Assigned(FOnDrawItem) then
        FOnDrawItem(Self, aCanvas, Index, R, State)
      else
      begin
        if Dropped or not ComboBox.Focused then
        begin
          aCanvas.Brush.Color := Color;
          aCanvas.Font.Color := Font.Color;
        end
        else
        begin
          aCanvas.Brush.Color := clHighlight;
          aCanvas.Font.Color := clHighlightText;
        end;
        aCanvas.FillRect(R);
        if Index <> -1 then
          aCanvas.TextRect(R, R.Left + 1, R.Top +
            (R.Bottom - R.Top - aCanvas.TextHeight('X')) div 2,
            (Control as TComboBox).Items[Index])
        else
          aCanvas.TextRect(R, R.Left + 1, R.Top +
            (R.Bottom - R.Top - aCanvas.TextHeight('X')) div 2, ' ');
      end;
      if (odFocused in State) and not Dropped and (ComboBox.Focused) then
        aCanvas.DrawFocusRect(R);
    finally
      aCanvas.Free;
      ReleaseDC(Editor.Handle, editDC);
    end;
  end
  else
  if Assigned(FOnDrawItem) then
    FOnDrawItem(Self, (Control as TComboBox).Canvas, Index, R, State)
  else
  begin
    (Control as TComboBox).Canvas.FillRect(R);
    if Index <> -1 then
      (Control as TComboBox).Canvas.TextRect(R, R.Left + 1, R.Top +
        (R.Bottom - R.Top - (Control as TComboBox).Canvas.TextHeight('X')) div 2,
        (Control as TComboBox).Items[Index]);
  end;
end;

procedure TComboBox97.ButtonDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Assigned(FOnDragDrop) then
    FOnDragDrop(Self, Source, X + Button.Left, Y + Button.Top);
end;

procedure TComboBox97.ButtonDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  DraggingOver(Sender, Source, X, Y, State, Accept);
end;

procedure TComboBox97.ComboBoxMeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
begin
  if Assigned(FOnMeasureItem) then
    FOnMeasureItem(Control, Index, Height);
end;

procedure TComboBox97.ComboBoxChange(Sender: TObject);
begin
  if Style in [csDropDownList, csOwnerDrawFixed, csOwnerDrawVariable] then
    if Assigned(FOnChange) then
      FOnChange(Self);
end;

procedure TComboBox97.ComboBoxClick(Sender: TObject);
begin
  if Assigned(FOnClick) then
    FOnClick(Self);
end;

procedure TComboBox97.ComboBoxDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Assigned(FOnDragDrop) then
    FOnDragDrop(Self, Source, X + ComboBox.Left, Y + ComboBox.Top);
end;

procedure TComboBox97.ComboBoxDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  DraggingOver(Sender, Source, X, Y, State, Accept);
end;

procedure TComboBox97.ComboBoxEnter(Sender: TObject);
begin
  if Editor.Enabled then
    Editor.SetFocus
  else
  begin
    ComboBoxDrawItem(ComboBox, ComboBox.ItemIndex, Rect(0,0,0,0),
      [odFocused, odSelected]);
    SendMessage(Handle, WM_NCPAINT, 0, 0);
    if Assigned(FOnEnter) then
      FOnEnter(Self);
  end;
end;

procedure TComboBox97.ComboBoxExit(Sender: TObject);
begin
  if not Editor.Enabled then
  begin
    ComboBoxDrawItem(ComboBox, ComboBox.ItemIndex, Rect(0,0,0,0),
      [odFocused, odSelected]);
    SendMessage(Handle, WM_NCPAINT, 0, 0);
    if Assigned(FOnExit) then
      FOnExit(Self);
  end;
end;

procedure TComboBox97.ComboBoxKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Assigned(FOnKeyDown) then
    FOnKeyDown(Sender, Key, Shift);
end;

procedure TComboBox97.ComboBoxKeyPress(Sender: TObject; var Key: Char);
begin
  if Assigned(FOnKeyPress) then
    FOnKeyPress(Sender, Key);
end;

procedure TComboBox97.ComboBoxKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if Assigned(FOnKeyUp) then
    FOnKeyUp(Sender, Key, Shift);
end;

procedure TComboBox97.ComboBoxSetText(Sender: TObject);
begin
  if not EditUpdate then
  begin
    Editor.Text := ComboBox.Text;
    Editor.SelStart := 0;
    Editor.SelLength := -1;
  end;
  EditUpdate := False;
end;

procedure TComboBox97.EditorChange(Sender: TObject);
begin
  if Style in [csDropDown, csSimple] then
  begin
    EditUpdate := True;
    ComboBox.Text := Editor.Text;
    if Assigned(FOnChange) then
      FOnChange(Self);
  end;
end;

procedure TComboBox97.EditorDblClick(Sender: TObject);
begin
  if Style in [csDropDown, csSimple] then
    if Assigned(FOnDblClick) then
      FOnDblClick(Self);
end;

procedure TComboBox97.EditorDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Assigned(FOnDragDrop) then
    FOnDragDrop(Self, Source, X + Editor.Left, Y + Editor.Top);
end;

procedure TComboBox97.EditorDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  DraggingOver(Sender, Source, X, Y, State, Accept);
end;

procedure TComboBox97.EditorEnter(Sender: TObject);
begin
  SendMessage(Handle, WM_NCPAINT, 0, 0);
  if Assigned(FOnEnter) then
    FOnEnter(Self);
end;

procedure TComboBox97.EditorExit(Sender: TObject);
begin
  SendMessage(Handle, WM_NCPAINT, 0, 0);
  if Assigned(FOnExit) then
    FOnExit(Self);
end;

procedure TComboBox97.EditorKeyPress(Sender: TObject; var Key: Char);
begin
  if Assigned(FOnKeyPress) then
    FOnKeyPress(Sender, Key);
end;

procedure TComboBox97.DraggingOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
  P: TPoint;
begin
  Accept := False;
  if (DraggingStatus = Ord(dsDragMove)) and (Ord(State) = 0) then
    State := dsDragMove;
  if (State = dsDragLeave) then
  begin
    GetCursorPos(P);
    P := ScreenToClient(P);
    if PtInRect(ClientRect, P) then
      State := dsDragMove;
  end;
  DraggingStatus := Ord(State);
  if Assigned(FOnDragOver) then
    if (Sender is TInplaceEdit97) or (Sender is TInplaceButton97) or
      (Sender is TInplaceComboBox97) then
      FOnDragOver(Self, Source, X + (Sender as TControl).Left,
        Y + (Sender as TControl).Top, State, Accept)
    else
      FOnDragOver(Self, Source, X, Y, State, Accept);
end;

function TComboBox97.GetColor: TColor;
begin
  Result := ComboBox.Color;
end;

function TComboBox97.GetComboBoxHandle: HWND;
begin
  Result := ComboBox.Handle;
end;

function TComboBox97.GetDropDownCount: Integer;
begin
  Result := ComboBox.DropDownCount;
end;

function TComboBox97.GetDroppedWidth: Integer;
begin
  if ComboBox.FDroppedWidth < 0 then
    Result := 0
  else
    Result := ComboBox.FDroppedWidth;
end;

function TComboBox97.GetEditHandle: HWND;
begin
  Result := Editor.Handle;
end;

function TComboBox97.GetItemHeight: Integer;
begin
  Result := ComboBox.ItemHeight;
end;

function TComboBox97.GetItems: TStrings;
begin
  Result := ComboBox.Items;
end;

function TComboBox97.GetMaxLength: Integer;
begin
  Result := ComboBox.MaxLength;
end;

function TComboBox97.GetMouseIn: Boolean;
begin
  Result := ((csDesigning in ComponentState) or (FocusedControl97 = Self) or
    ((FocusedControl97 = nil) and (MouseInControl97 = Self))) and Enabled and
    Application.Active;
end;

function TComboBox97.GetParentColor: Boolean;
begin
  Result := ComboBox.ParentColor;
end;

function TComboBox97.GetSorted: Boolean;
begin
  Result := ComboBox.Sorted;
end;

function TComboBox97.GetStyle: TComboBoxStyle;
begin
  Result := ComboBox.Style;
end;

function TComboBox97.GetText: TCaption;
begin
  if csDesigning in ComponentState then
    ComboBox.Text := Caption;
  Result := Editor.Text;
end;

procedure TComboBox97.SetAutoSize(Value: Boolean);
var
  DC: HDC;
  aCanvas: TCanvas;
begin
  FAutoSize := Value;
  if FAutoSize then
  begin
    DC := GetDC(Handle);
    try
      aCanvas := TCanvas.Create;
      try
        aCanvas.Handle := DC;
        aCanvas.Font := Font;
        Height := aCanvas.TextHeight('X') + 2*BORDERWIDTH;
      finally
        aCanvas.Free;
      end;
    finally
      ReleaseDC(Handle, DC);
    end;
  end;
end;

procedure TComboBox97.SetBackgroundColor(Value: TColor);
begin
  if Value <> FBackgroundColor then
  begin
    FBackgroundColor := Value;
    Invalidate;
    SendMessage(Handle, WM_NCPAINT, 0, 0);
  end;
end;

procedure TComboBox97.SetColor(Value: TColor);
begin
  ComboBox.Color := Value;
  Editor.Color := Value;
end;

procedure TComboBox97.SetDropDownCount(Value: Integer);
begin
  ComboBox.DropDownCount := Value;
end;

procedure TComboBox97.SetDroppedWidth(Value: Integer);
begin
  if Value <= 0 then
    ComboBox.FDroppedWidth := -Width
  else
    ComboBox.FDroppedWidth := Value;
end;

procedure TComboBox97.SetItemHeight(Value: Integer);
begin
  ComboBox.ItemHeight := Value;
end;

procedure TComboBox97.SetItems(Value: TStrings);
begin
  ComboBox.Items := Value;
end;

procedure TComboBox97.SetMaxLength(Value: Integer);
begin
  ComboBox.MaxLength := Value;
  Editor.MaxLength := Value;
end;

procedure TComboBox97.SetParentColor(Value: Boolean);
begin
  ComboBox.ParentColor := Value;
  Editor.ParentColor := Value;
end;

procedure TComboBox97.SetSorted(Value: Boolean);
begin
  ComboBox.Sorted := Value;
end;

procedure TComboBox97.SetStyle(Value: TComboBoxStyle);
begin
  if ComboBox.Style <> Value then
  begin
    ComboBox.Style := Value;
    Editor.Enabled := (Value = csDropDown) or (Value = csSimple);
    ComboBox.TabStop := not Editor.Enabled and FTabStop;
    Editor.TabStop := Editor.Enabled and FTabStop;
    Button.Width := Ord(Value <> csSimple) * BUTTONWIDTH;
    SendMessage(Handle, WM_SIZE, 0, ClientWidth + 65536*ClientHeight);
    SendMessage(Handle, WM_NCPAINT, 0, 0);
  end;
end;

procedure TComboBox97.SetTabStop(Value: Boolean);
begin
  if Value <> FTabStop then
  begin
    FTabStop := Value;
    ComboBox.TabStop := not Editor.Enabled and FTabStop;
    Editor.TabStop := Editor.Enabled and FTabStop;
  end;
end;

procedure TComboBox97.SetText(Value: TCaption);
begin
  Caption := Value;
  ComboBox.Text := Value;
end;

procedure TComboBox97.CMEnabledChanged(var Message: TMessage);
begin
  inherited;
  Editor.Invalidate;
  SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TComboBox97.CMFontChanged(var Message: TMessage);
begin
  inherited;
  AutoSize := FAutoSize;
end;

procedure TComboBox97.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  MouseInControl97 := Self;
  if (FocusedControl97 = nil) then
    SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TComboBox97.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if (MouseInControl97 = Self) then
    MouseInControl97 := nil;
  if (FocusedControl97 <> Self) then
    SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TComboBox97.WMDrag(var Message: TMessage);
begin
  BeginDrag(True);
end;

procedure TComboBox97.WMLButtonDown(var Message: TWMLButtonDown);
var
  aIndex: Integer;
begin
  inherited;
  DropDownEx := not Dropped;
  if DropDownEx then
  begin
    aIndex := ComboBox.ItemIndex;
    SendMessage(ComboBox.Handle, WM_LBUTTONDOWN, 0, 0);
    ComboBox.ItemIndex := aIndex;
  end;
end;

procedure TComboBox97.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  with Message.CalcSize_Params^ do
  begin
    InflateRect(rgrc[0], -BORDERWIDTH, -BORDERWIDTH);
  end;
  inherited;
end;

procedure TComboBox97.WMNCPaint(var Message: TWMNCPaint);
var
  DC: HDC;
  RC, MemRC: TRect;
  aCanvas: TCanvas;
begin
  DC := GetWindowDC(Handle);
  try
    Windows.GetClientRect(Handle, RC);
    OffsetRect(RC, BORDERWIDTH, BORDERWIDTH);
    InflateRect(RC, BORDERWIDTH, BORDERWIDTH);
    ExcludeClipRect(DC, RC.Left + BORDERWIDTH, RC.Top + BORDERWIDTH,
      RC.Right - BORDERWIDTH, RC.Bottom - BORDERWIDTH);
    GlobalBrush.Color := ColorToRGB(BackgroundColor);
    Windows.FillRect(DC, RC, GlobalBrush.Handle);
    if MouseIn then
    begin
      aCanvas := TCanvas.Create;
      try
        aCanvas.Handle := DC;
        aCanvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 120);
        aCanvas.MoveTo(RC.Left, RC.Bottom);
        aCanvas.LineTo(RC.Left, RC.Top);
        aCanvas.LineTo(RC.Right - 1, RC.Top);
        aCanvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210);
        aCanvas.LineTo(RC.Right - 1, RC.Bottom - 1);
        aCanvas.LineTo(RC.Left, RC.Bottom - 1);
      finally
        aCanvas.Free;
      end;
    end;
    InflateRect(RC, -2, -2);
    MemRC := RC;
    if Style <> csSimple then
    begin
      Dec(RC.Right, BUTTONWIDTH + 1);
      if not(Enabled) then
        GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 210)
      else
        GlobalBrush.Color := ColorToRGB(Color);
      Windows.FrameRect(DC, RC, GlobalBrush.Handle);
      RC := MemRC;
      Inc(RC.Left, ClientWidth - BUTTONWIDTH + 1);
      if MouseIn then
        Inc(RC.Left);
      if MouseIn then
        GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 120)
      else
        GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 210);
      Windows.FrameRect(DC, RC, GlobalBrush.Handle);
      if MouseIn then
      begin
        if Button.Down then
          GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 120)
        else
          GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 210);
        Dec(RC.Right);
        Dec(RC.Bottom);
        Windows.FrameRect(DC, RC, GlobalBrush.Handle);
      end;
      if MouseIn then
      begin
        GlobalBrush.Color := ColorToRGB(clBtnFace);
        Windows.FrameRect(DC, Rect(RC.Left - 1, RC.Top, RC.Left, RC.Bottom + 1), GlobalBrush.Handle);
      end;
    end
    else
    begin
      if Enabled then
        GlobalBrush.Color := ColorToRGB(Color)
      else
        GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 210);
      Windows.FrameRect(DC, RC, GlobalBrush.Handle);
    end;
  finally
    ReleaseDC(Handle, DC);
  end;
  Button.Repaint;
end;

procedure TComboBox97.WMSize(var Message: TWMSize);
begin
  if FAutoSize then
  begin
    AutoSize := FAutoSize;
    Message.Height := Height - 2*BORDERWIDTH;
  end;
  inherited;
  Editor.SetBounds(0, 0, Message.Width - Button.Width, Message.Height);
  Button.SetBounds(Message.Width - Button.Width, 0, Button.Width, Message.Height);
  if DroppedWidth = 0 then
    ComboBox.FDroppedWidth := -Width;
end;

constructor TCustomEdit97.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  BorderStyle := bsNone;
end;

constructor TEdit97.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FAutoSize := True;
  FBackgroundColor := clBtnFace;
  FDisabledState := dsOffice97;
  AdjustHeight;
end;

procedure TEdit97.CreateWnd;
begin
  inherited CreateWnd;
  UpdateHeight;
end;

function TEdit97.GetBorderStyle: TBorderStyle;
begin
  Result := bsNone;
end;

function TEdit97.GetMouseIn: Boolean;
begin
  Result := ((csDesigning in ComponentState) or (FocusedControl97 = Self) or
    ((FocusedControl97 = nil) and (MouseInControl97 = Self))) and Enabled and
    Application.Active;
end;

procedure TEdit97.SetAutoSize(Value: Boolean);
begin
  if Value <> FAutoSize then
  begin
    FAutoSize := Value;
    UpdateHeight;
  end;
end;

procedure TEdit97.SetBackgroundColor(Value: TColor);
begin
  if Value <> FBackgroundColor then
  begin
    FBackgroundColor := Value;
    Invalidate;
    SendMessage(Handle, WM_NCPAINT, 0, 0);
  end;
end;

procedure TEdit97.SetBorderStyle(Value: TBorderStyle);
begin
  // nothing
end;

procedure TEdit97.SetDisabledState(Value: TDisabledState);
begin
  if Value <> FDisabledState then
  begin
    FDisabledState := Value;
    if not Enabled then
      Invalidate;
  end;
end;

function TEdit97.CalcAdjustHeight: Integer;
var
  DC: HDC;
  SaveFont: HFont;
  I: Integer;
  SysMetrics, Metrics: TTextMetric;
begin
  DC := GetDC(0);
  GetTextMetrics(DC, SysMetrics);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  if Ctl3D then
    I := 8
  else
    I := 6;
  I := GetSystemMetrics(SM_CYBORDER) * I;
  Result := Metrics.tmHeight + I;
end;

procedure TEdit97.AdjustHeight;
begin
  Height := CalcAdjustHeight;
end;

procedure TEdit97.UpdateHeight;
begin
  if FAutoSize then
  begin
    ControlStyle := ControlStyle + [csFixedHeight];
    AdjustHeight;
  end else
    ControlStyle := ControlStyle - [csFixedHeight];
end;

procedure TEdit97.CMEnabledChanged(var Message: TMessage);
begin
  inherited;
  SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TEdit97.CMFontChanged(var Message: TMessage);
begin
  inherited;
  if not((csDesigning in ComponentState) and (csLoading in ComponentState)) and
    FAutoSize then
    AdjustHeight;
end;

procedure TEdit97.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  MouseInControl97 := Self;
  if (FocusedControl97 = nil) then
    SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TEdit97.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if (MouseInControl97 = Self) then
    MouseInControl97 := nil;
  if (FocusedControl97 <> Self) then
    SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TEdit97.WMNCCalcSize(var Message: TWMNCCalcSize);
begin
  with Message.CalcSize_Params^ do
  begin
    InflateRect(rgrc[0], -BORDERWIDTH, -BORDERWIDTH);
  end;
  inherited;
end;

procedure TEdit97.WMNCPaint(var Message: TWMNCPaint);
var
  DC: HDC;
  RC, MemRC: TRect;
  aCanvas: TCanvas;
begin
  DC := GetWindowDC(Handle);
  try
    Windows.GetClientRect(Handle, RC);
    OffsetRect(RC, BORDERWIDTH, BORDERWIDTH);
    InflateRect(RC, BORDERWIDTH, BORDERWIDTH);
    ExcludeClipRect(DC, RC.Left + BORDERWIDTH, RC.Top + BORDERWIDTH,
      RC.Right - BORDERWIDTH, RC.Bottom - BORDERWIDTH);
    GlobalBrush.Color := ColorToRGB(FBackgroundColor);
    Windows.FillRect(DC, RC, GlobalBrush.Handle);
    if MouseIn then
    begin
      aCanvas := TCanvas.Create;
      try
        aCanvas.Handle := DC;
        aCanvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 120);
        aCanvas.MoveTo(RC.Left, RC.Bottom);
        aCanvas.LineTo(RC.Left, RC.Top);
        aCanvas.LineTo(RC.Right - 1, RC.Top);
        aCanvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210);
        aCanvas.LineTo(RC.Right - 1, RC.Bottom - 1);
        aCanvas.LineTo(RC.Left, RC.Bottom - 1);
      finally
        aCanvas.Free;
      end;
    end;
    InflateRect(RC, -2, -2);
    MemRC := RC;
    if Enabled then
      GlobalBrush.Color := ColorToRGB(Color)
    else
      GlobalBrush.Color := LumColor(ColorToRGB(clBtnFace), 210);
    Windows.FrameRect(DC, RC, GlobalBrush.Handle);
  finally
    ReleaseDC(Handle, DC);
  end;
end;

procedure TEdit97.WMPaint(var Message: TWMPaint);
var
  DC: HDC;
  RC: TRect;
begin
  inherited;
  if not(Enabled) and (FDisabledState = dsOffice97) then
  begin
    DC := GetDC(Handle);
    try
      Windows.GetClientRect(Handle, RC);
      GlobalBrush.Color := ColorToRGB(FBackgroundColor);
      Windows.FillRect(DC, RC, GlobalBrush.Handle);
    finally
      ReleaseDC(Handle, DC);
    end;
  end;
end;

procedure TEdit97.WMSize(var Message: TWMSize);
begin
  inherited;
  if FAutoSize then
    if Message.Height <> CalcAdjustHeight then
      Height := CalcAdjustHeight;
end;

procedure TEdit97.WMSetFocus(var Message: TWMSetFocus);
var
  AControl: TWinControl;
begin
  inherited;
  AControl := FocusedControl97;
  FocusedControl97 := Self;
  if (AControl <> nil) then
    SendMessage(AControl.Handle, WM_NCPAINT, 0, 0)
  else
  if (MouseInControl97 <> nil) then
    UpdateMouseInControl;
  SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

procedure TEdit97.WMKillFocus(var Message: TWMKillFocus);
begin
  inherited;
  if FocusedControl97 = Self then
  begin
    FocusedControl97 := nil;
    if (MouseInControl97 <> nil) then
      UpdateMouseInControl;
  end;
  SendMessage(Handle, WM_NCPAINT, 0, 0);
end;

constructor TSpeedButton97.Create(AOwner: TComponent);
begin
  inherited;
  ControlStyle := [csCaptureMouse, csDoubleClicks, csOpaque];
  FBackgroundColor := clBtnFace;
  FOpaque := True;
end;

function TSpeedButton97.GetFlat: Boolean;
begin
  Result := True;
end;

function TSpeedButton97.GetMouseIn: Boolean;
begin
  Result := ((csDesigning in ComponentState) or
    ((FocusedControl97 = nil) and (MouseInControl97 = Self))) and Enabled and
    Application.Active;
end;

procedure TSpeedButton97.SetBorderAlwaysVisible(Value: Boolean);
begin
  if FBorderAlwaysVisible <> Value then
  begin
    FBorderAlwaysVisible := Value;
    Invalidate;
  end;
end;

procedure TSpeedButton97.SetBackgroundColor(Value: TColor);
begin
  if FBackgroundColor <> Value then
  begin
    FBackgroundColor := Value;
    Invalidate;
  end;
end;

procedure TSpeedButton97.SetFlat(Value: Boolean);
begin
  // nothing
end;

procedure TSpeedButton97.SetNoBorder(Value: Boolean);
begin
  if FNoBorder <> Value then
  begin
    FNoBorder := Value;
    Invalidate;
  end;
end;

procedure TSpeedButton97.SetNoHighlight(Value: Boolean);
begin
  if FNoHighlight <> Value then
  begin
    FNoHighlight := Value;
    Invalidate;
  end;
end;

procedure TSpeedButton97.SetOpaque(Value: Boolean);
begin
  if FOpaque <> Value then
  begin
    FOpaque := Value;
    if FOpaque then
      ControlStyle := ControlStyle + [csOpaque]
    else
      ControlStyle := ControlStyle - [csOpaque];
    Invalidate;
  end;
end;

procedure TSpeedButton97.CMMouseEnter(var Message: TMessage);
begin
  inherited;
  MouseInControl97 := Self;
  if (FocusedControl97 = nil) then
    if (Down and not(FNoHighlight)) or InClick then
      Repaint
    else
      DrawBorder;
end;

procedure TSpeedButton97.CMMouseLeave(var Message: TMessage);
begin
  inherited;
  if (MouseInControl97 = Self) then
    MouseInControl97 := nil;
  if (Down and not(FNoHighlight)) or InClick then
    Repaint
  else
    DrawBorder;
end;

procedure TSpeedButton97.WMLButtonDown(var Message: TWMLButtonDown);
begin
  InClick := True;
  if FocusedControl97 <> nil then
    Windows.SetFocus(0);
  inherited;
  if Down then
    Repaint;
end;

procedure TSpeedButton97.WMLButtonUp(var Message: TWMLButtonUp);
begin
  InClick := False;
  inherited;
  if (GroupIndex = 0) and not(MouseIn) then
    DrawBorder;
end;

procedure TSpeedButton97.CreateBrushPattern;
var
  X, Y: Integer;
begin
  Pattern := TBitmap.Create;
  Pattern.Width := 8;
  Pattern.Height := 8;
  with Pattern.Canvas do
  begin
    Brush.Style := bsSolid;
    Brush.Color := clBtnFace;
    FillRect(Rect(0, 0, Pattern.Width, Pattern.Height));
    for Y := 0 to 7 do
      for X := 0 to 7 do
        if (Y mod 2) = (X mod 2) then
          Pixels[X, Y] := clBtnHighlight;
  end;
end;

procedure TSpeedButton97.DrawBorder;
var
  R: TRect;
begin
  if FOpaque then
  begin
    Canvas.Brush.Color := FBackgroundColor;
    R := Rect(1, 1, Width - 1, Height - 1);
    Canvas.FrameRect(R);
  end;
  if (Down or (InClick and MouseIn)) and not(FNoBorder) then
  begin
    Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210);
    Canvas.MoveTo(0, Height - 1);
    Canvas.LineTo(Width - 1, Height - 1);
    Canvas.LineTo(Width - 1, - 1);
    Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 120);
    Canvas.MoveTo(0, Height - 2);
    Canvas.LineTo(0, 0);
    Canvas.LineTo(Width - 1, 0);
  end
  else
  if ((MouseIn or InClick) or FBorderAlwaysVisible) and not(FNoBorder) then
  begin
    Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 120);
    Canvas.MoveTo(0, Height - 1);
    Canvas.LineTo(Width - 1, Height - 1);
    Canvas.LineTo(Width - 1, - 1);
    Canvas.Pen.Color := LumColor(ColorToRGB(clBtnFace), 210);
    Canvas.MoveTo(0, Height - 2);
    Canvas.LineTo(0, 0);
    Canvas.LineTo(Width - 1, 0);
  end
  else
  if FOpaque then
  begin
    Canvas.Brush.Color := FBackgroundColor;
    R := Rect(0, 0, Width, Height);
    Canvas.FrameRect(R);
  end;
end;

procedure TSpeedButton97.Paint;

  procedure CalcButtonLayout(Canvas: TCanvas; const Client: TRect;
    const Offset: TPoint; const Caption: string; Layout: TButtonLayout; Margin,
    Spacing: Integer; var GlyphPos: TPoint; var TextBounds: TRect);
  var
    TextPos: TPoint;
    ClientSize, GlyphSize, TextSize: TPoint;
    TotalSize: TPoint;
  begin
    ClientSize := Point(Client.Right - Client.Left, Client.Bottom -
      Client.Top);
    if Glyph <> nil then
      GlyphSize := Point(Glyph.Width div NumGlyphs, Glyph.Height)
    else
      GlyphSize := Point(0, 0);
    if Length(Caption) > 0 then
    begin
      TextBounds := Rect(0, 0, Client.Right - Client.Left, 0);
      DrawText(Canvas.Handle, PChar(Caption), Length(Caption), TextBounds,
        DT_CALCRECT);
      TextSize := Point(TextBounds.Right - TextBounds.Left, TextBounds.Bottom -
        TextBounds.Top);
    end
    else
    begin
      TextBounds := Rect(0, 0, 0, 0);
      TextSize := Point(0,0);
    end;
    if Layout in [blGlyphLeft, blGlyphRight] then
    begin
      GlyphPos.Y := (ClientSize.Y - GlyphSize.Y + 1) div 2;
      TextPos.Y := (ClientSize.Y - TextSize.Y + 1) div 2;
    end
    else
    begin
      GlyphPos.X := (ClientSize.X - GlyphSize.X + 1) div 2;
      TextPos.X := (ClientSize.X - TextSize.X + 1) div 2;
    end;
    if (TextSize.X = 0) or (GlyphSize.X = 0) then
      Spacing := 0;
    if Margin = -1 then
    begin
      if Spacing = -1 then
      begin
        TotalSize := Point(GlyphSize.X + TextSize.X, GlyphSize.Y + TextSize.Y);
        if Layout in [blGlyphLeft, blGlyphRight] then
          Margin := (ClientSize.X - TotalSize.X) div 3
        else
          Margin := (ClientSize.Y - TotalSize.Y) div 3;
        Spacing := Margin;
      end
      else
      begin
        TotalSize := Point(GlyphSize.X + Spacing + TextSize.X, GlyphSize.Y +
          Spacing + TextSize.Y);
        if Layout in [blGlyphLeft, blGlyphRight] then
          Margin := (ClientSize.X - TotalSize.X + 1) div 2
        else
          Margin := (ClientSize.Y - TotalSize.Y + 1) div 2;
      end;
    end
    else
    begin
      if Spacing = -1 then
      begin
        TotalSize := Point(ClientSize.X - (Margin + GlyphSize.X), ClientSize.Y -
          (Margin + GlyphSize.Y));
        if Layout in [blGlyphLeft, blGlyphRight] then
          Spacing := (TotalSize.X - TextSize.X) div 2
        else
          Spacing := (TotalSize.Y - TextSize.Y) div 2;
      end;
    end;
    case Layout of
      blGlyphLeft:
        begin
          GlyphPos.X := Margin;
          TextPos.X := GlyphPos.X + GlyphSize.X + Spacing;
        end;
      blGlyphRight:
        begin
          GlyphPos.X := ClientSize.X - Margin - GlyphSize.X;
          TextPos.X := GlyphPos.X - Spacing - TextSize.X;
        end;
      blGlyphTop:
        begin
          GlyphPos.Y := Margin;
          TextPos.Y := GlyphPos.Y + GlyphSize.Y + Spacing;
        end;
      blGlyphBottom:
        begin
          GlyphPos.Y := ClientSize.Y - Margin - GlyphSize.Y;
          TextPos.Y := GlyphPos.Y - Spacing - TextSize.Y;
        end;
    end;
    with GlyphPos do
    begin
      Inc(X, Client.Left + Offset.X);
      Inc(Y, Client.Top + Offset.Y);
    end;
    OffsetRect(TextBounds, TextPos.X + Client.Left + Offset.X,
      TextPos.Y + Client.Top + Offset.X);
  end;

var
  Bmp: TBitmap;
  TextBounds, SourceRect: TRect;
  Offset, GlyphPos: TPoint;
begin
  if Down and not(MouseIn) and not(FNoHighlight) and not(InClick) then
  begin
    CreateBrushPattern;
    Canvas.Brush.Bitmap := Pattern;
    Canvas.FillRect(Rect(0, 0, Width, Height));
    Pattern.Free;
  end
  else
  if FOpaque then
  begin
    Canvas.Brush.Color := clBtnFace;
    Canvas.FillRect(Rect(0, 0, Width, Height));
  end;
  Canvas.Font := Font;
  if Down and InClick and MouseIn then
    Offset := Point(2, 2)
  else
  if Down or (InClick and MouseIn) then
    Offset := Point(1, 1)
  else
    Offset := Point(0, 0);
  CalcButtonLayout(Canvas, Rect(0, 0, Width, Height), Offset, Caption, Layout,
    Margin, Spacing, GlyphPos, TextBounds);
  with Canvas do
  begin
    Brush.Style := bsClear;
    if not Enabled then
    begin
      OffsetRect(TextBounds, 1, 1);
      Font.Color := clBtnHighlight;
      DrawText(Handle, PChar(Caption), Length(Caption), TextBounds,
        DT_CENTER or DT_WORDBREAK);
      OffsetRect(TextBounds, -1, -1);
      Font.Color := clBtnShadow;
      DrawText(Handle, PChar(Caption), Length(Caption), TextBounds,
        DT_CENTER or DT_WORDBREAK);
    end
    else
      DrawText(Handle, PChar(Caption), Length(Caption), TextBounds,
        DT_CENTER or DT_WORDBREAK);
  end;
  if Assigned(Glyph) and (Glyph.Width > 0) and (Glyph.Height > 0) then
  begin
    Bmp := TBitmap.Create;
    try
      Bmp.Width := Glyph.Width div NumGlyphs;
      Bmp.Height := Glyph.Height;
      if not Enabled and (NumGlyphs >= 2) then
        SourceRect := Rect(Bmp.Width, 0, 2 * Bmp.Width, Bmp.Height)
      else
      if not Down and InClick and MouseIn and (NumGlyphs >= 3) then
        SourceRect := Rect(2 * Bmp.Width, 0, 3 * Bmp.Width, Bmp.Height)
      else
      if Down and (NumGlyphs >= 4) then
        SourceRect := Rect(3 * Bmp.Width, 0, 4 * Bmp.Width, Bmp.Height)
      else
        SourceRect := Rect(0, 0, Bmp.Width, Bmp.Height);
      Bmp.Canvas.CopyRect(Rect(0, 0, Bmp.Width, Bmp.Height), Glyph.Canvas,
        SourceRect);
      Bmp.Transparent := True;
      Canvas.Draw(GlyphPos.X, GlyphPos.Y, Bmp);
    finally
      Bmp.Free;
    end;
  end;
  DrawBorder;
end;

initialization
  FocusedControl97 := nil;
  MouseInControl97 := nil;
  GlobalBrush := TBrush.Create;

finalization
  GlobalBrush.Free;

end.
